#ifdef ATL_UCLEANN
#define ATL_dJIK64x0x64TN64x64x0_a1_b1 ATL_dgpNBmm_b1
#else
#define ATL_dJIK64x0x64TN64x64x0_a1_b1 ATL_dpNBmm_b1
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK4x0x64TN4x1x16_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=4, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=4, nu=1, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *stM = A + 256;
   const double *stN = B + (((Nb) << 6));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(4*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 16
   const int incAm = 192, incAn = -256;
   #define incBk 16
   const int incBm = -64, incBn = 64;
   #define incCm 4
   const int incCn = (ldc) - 4;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rC0_0 = *pC0;
      rC1_0 = pC0[1];
      rC2_0 = pC0[2];
      rC3_0 = pC0[3];
      for (k=64; k; k -= 16) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA1 = pA0[64];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[128];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[192];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[65];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[129];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[193];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[66];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[130];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[194];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[67];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[131];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[195];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[68];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[132];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[196];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[69];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[133];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[197];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[70];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[134];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[198];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[71];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[135];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[199];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[72];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[136];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[200];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[73];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[137];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[201];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[74];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[138];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[202];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[75];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[139];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[203];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[76];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[140];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[204];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[77];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[141];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[205];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[78];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[142];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[206];
         rC3_0 += rA3 * rB0;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[79];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[143];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[207];
         rC3_0 += rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK64x0x64TN5x1x16_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=64, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=5, nu=1, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 3840;
   const double *stN = B + (((Nb) << 6));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*1)/(64*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 16
   const int incAm = 256, incAn = -3840;
   #define incBk 16
   const int incBm = -64, incBn = 64;
   #define incCm 5
   const int incCn = (ldc) - 60;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[1];
         rC2_0 = pC0[2];
         rC3_0 = pC0[3];
         rC4_0 = pC0[4];
         for (k=64; k; k -= 16) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA1 = pA0[64];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[128];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[192];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[256];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[65];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[129];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[193];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[257];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[66];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[130];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[194];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[258];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[67];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[131];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[195];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[259];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[68];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[132];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[196];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[260];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[69];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[133];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[197];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[261];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[70];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[134];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[198];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[262];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[71];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[135];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[199];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[263];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[72];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[136];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[200];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[264];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[73];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[137];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[201];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[265];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[74];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[138];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[202];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[266];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[75];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[139];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[203];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[267];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[76];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[140];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[204];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[268];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[77];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[141];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[205];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[269];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[78];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[142];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[206];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[270];
            rC4_0 += rA4 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[79];
            rC1_0 += rA1 * rB0;
            rA2 = pA0[143];
            rC2_0 += rA2 * rB0;
            rA3 = pA0[207];
            rC3_0 += rA3 * rB0;
            rA4 = pA0[271];
            rC4_0 += rA4 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK4x0x64TN4x1x16_a1_b1(4, N, 64, alpha, ca + 3840, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK4x0x64TN4x4x16_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=4, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=4, nu=4, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>2)<<2;
   const double *stM = A + 256;
   const double *stN = B + (((Nb) << 6));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*4)/(4*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 16
   const int incAm = 192, incAn = -256;
   #define incBk 16
   const int incBm = -64, incBn = 256;
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 4;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rC0_0 = *pC0;
      rC1_0 = pC0[1];
      rC2_0 = pC0[2];
      rC3_0 = pC0[3];
      rC0_1 = *pC1;
      rC1_1 = pC1[1];
      rC2_1 = pC1[2];
      rC3_1 = pC1[3];
      rC0_2 = *pC2;
      rC1_2 = pC2[1];
      rC2_2 = pC2[2];
      rC3_2 = pC2[3];
      rC0_3 = *pC3;
      rC1_3 = pC3[1];
      rC2_3 = pC3[2];
      rC3_3 = pC3[3];
      for (k=64; k; k -= 16) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA1 = pA0[64];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[128];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[192];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[64];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[128];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[192];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[65];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[129];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[193];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[65];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[129];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[193];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[66];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[130];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[194];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[66];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[130];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[194];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[67];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[131];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[195];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[67];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[131];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[195];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[68];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[132];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[196];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[68];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[132];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[196];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[69];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[133];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[197];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[69];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[133];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[197];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[70];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[134];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[198];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[70];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[134];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[198];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[71];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[135];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[199];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[71];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[135];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[199];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[72];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[136];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[200];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[72];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[136];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[200];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[73];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[137];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[201];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[73];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[137];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[201];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[74];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[138];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[202];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[74];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[138];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[202];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[75];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[139];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[203];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[75];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[139];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[203];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[76];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[140];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[204];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[76];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[140];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[204];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[77];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[141];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[205];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[77];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[141];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[205];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[78];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[142];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[206];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[78];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[142];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[206];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[79];
         rC1_0 += rA1 * rB0;
         rA2 = pA0[143];
         rC2_0 += rA2 * rB0;
         rA3 = pA0[207];
         rC3_0 += rA3 * rB0;
         rB1 = pB0[79];
         rC0_1 += rA0 * rB1;
         rB2 = pB0[143];
         rC1_1 += rA1 * rB1;
         rB3 = pB0[207];
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC3[2] = rC2_3;
      pC3[3] = rC3_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK64x0x64TN64x64x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=64, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=5, nu=4, ku=16, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N>>2)<<2;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 3840;
   const double *stN = B + (((Nb) << 6));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*4)/(64*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 16
   const int incAm = 256, incAn = -3840;
   #define incBk 16
   const int incBm = -64, incBn = 256;
   #define incCm 5
   const int incCn = (((ldc) << 2)) - 60;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = *pC0;
            rC1_0 = pC0[1];
            rC2_0 = pC0[2];
            rC3_0 = pC0[3];
            rC4_0 = pC0[4];
            rC0_1 = *pC1;
            rC1_1 = pC1[1];
            rC2_1 = pC1[2];
            rC3_1 = pC1[3];
            rC4_1 = pC1[4];
            rC0_2 = *pC2;
            rC1_2 = pC2[1];
            rC2_2 = pC2[2];
            rC3_2 = pC2[3];
            rC4_2 = pC2[4];
            rC0_3 = *pC3;
            rC1_3 = pC3[1];
            rC2_3 = pC3[2];
            rC3_3 = pC3[3];
            rC4_3 = pC3[4];
            for (k=64; k; k -= 16) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rC0_0 += rA0 * rB0;
               rA1 = pA0[64];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[128];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[192];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[256];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[64];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[128];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[192];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[65];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[129];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[193];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[257];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[65];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[129];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[193];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[66];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[130];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[194];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[258];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[66];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[130];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[194];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[67];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[131];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[195];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[259];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[67];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[131];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[195];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[68];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[132];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[196];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[260];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[68];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[132];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[196];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[69];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[133];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[197];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[261];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[69];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[133];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[197];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[70];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[134];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[198];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[262];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[70];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[134];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[198];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[71];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[135];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[199];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[263];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[71];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[135];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[199];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[72];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[136];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[200];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[264];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[72];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[136];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[200];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[73];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[137];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[201];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[265];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[73];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[137];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[201];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[74];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[138];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[202];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[266];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[74];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[138];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[202];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[75];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[139];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[203];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[267];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[75];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[139];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[203];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[76];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[140];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[204];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[268];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[76];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[140];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[204];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[77];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[141];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[205];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[269];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[77];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[141];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[205];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[78];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[142];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[206];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[270];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[78];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[142];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[206];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[79];
               rC1_0 += rA1 * rB0;
               rA2 = pA0[143];
               rC2_0 += rA2 * rB0;
               rA3 = pA0[207];
               rC3_0 += rA3 * rB0;
               rA4 = pA0[271];
               rC4_0 += rA4 * rB0;
               rB1 = pB0[79];
               rC0_1 += rA0 * rB1;
               rB2 = pB0[143];
               rC1_1 += rA1 * rB1;
               rB3 = pB0[207];
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC2_3 += rA2 * rB3;
               rC3_3 += rA3 * rB3;
               rC4_3 += rA4 * rB3;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            pC1[4] = rC4_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            pC2[4] = rC4_2;
            *pC3 = rC0_3;
            pC3[1] = rC1_3;
            pC3[2] = rC2_3;
            pC3[3] = rC3_3;
            pC3[4] = rC4_3;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK64x0x64TN5x1x16_a1_b1(64, k, 64, alpha, ca, lda, cb + (((Nb) << 6)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb)

      ATL_dJIK4x0x64TN4x4x16_a1_b1(4, Nb, 64, alpha, ca + 3840, lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
